unit WinUSB;

interface

uses
  Windows;

type
  USB_INTERFACE_DESCRIPTOR = packed record
    bLength,
    bDescriptorType,
    bInterfaceNumber,
    bAlternateSetting,
    bNumEndpoints,
    bInterfaceClass,
    bInterfaceSubClass,
    bInterfaceProtocol,
    iInterface: Byte;
  end;
  PUSB_INTERFACE_DESCRIPTOR = ^USB_INTERFACE_DESCRIPTOR;

  //USBD_PIPE_TYPE = (UsbdPipeTypeControl, UsbdPipeTypeIsochronous, UsbdPipeTypeBulk, UsbdPipeTypeInterrupt);

  WINUSB_PIPE_INFORMATION = packed record
    PipeType: LongWord;
    PipeId: Byte;
    MaximumPacketSize: Word;
    Interval: Byte;
  end;
  PWINUSB_PIPE_INFORMATION = ^WINUSB_PIPE_INFORMATION;

  TWinUSBSetupPacket = packed record
    RequestType,
    Request: Byte;
    Value,
    Index,
    DataLength: Word;
  end;

function WinUsb_Initialize(DeviceHandle: THandle; var InterfaceHandle: THandle): BOOL; stdcall; external 'WinUSB.dll';
function WinUsb_Free(InterfaceHandle: THandle): BOOL; stdcall; external 'WinUSB.dll';
function WinUsb_ControlTransfer(InterfaceHandle: THandle; SetupPacket: TWinUSBSetupPacket; Buffer: PByte; BufferLength: LongWord; var LengthTransferred: LongWord; Overlapped: POverlapped): BOOL; stdcall; external 'WinUSB.dll';
function WinUsb_GetDescriptor(InterfaceHandle: THandle; DescriptorType: Byte; Index: Byte; LanguageID: Word; Buffer: Pointer; BufferLength: LongWord; var LengthTransferred: LongWord): BOOL; stdcall; external 'WinUSB.dll';
function WinUsb_QueryInterfaceSettings(InterfaceHandle: THandle; AlternateSettingNumber: Byte; UsbAltInterfaceDescriptor: PUSB_INTERFACE_DESCRIPTOR): BOOL; stdcall; external 'WinUSB.dll';
function WinUsb_QueryPipe(InterfaceHandle: THandle; AlternateInterfaceNumber, PipeIndex: Byte; PipeInformation: PWINUSB_PIPE_INFORMATION): BOOL; stdcall; external 'WinUSB.dll';
function WinUsb_WritePipe(InterfaceHandle: THandle; PipeID: Byte; Buffer: PByte; BufferLength: LongWord; var LengthTransferred: LongWord; pOverlapped: Pointer): BOOL; stdcall; external 'WinUSB.dll';
function WinUsb_ReadPipe(InterfaceHandle: THandle; PipeID: Byte; Buffer: PByte; BufferLength: LongWord; var LengthTransferred: LongWord; pOverlapped: Pointer): BOOL; stdcall; external 'WinUSB.dll';

implementation

end.